]> git.ipfire.org Git - thirdparty/git.git/blobdiff - git-stash.sh
Merge branch 'jc/clone'
[thirdparty/git.git] / git-stash.sh
index f90dffd4caf88d649a9998a43aee18e57d3f594f..30425ce6df8b8da9b105fa7d8e958936420983ed 100755 (executable)
@@ -36,6 +36,9 @@ save_stash () {
        test -f "$GIT_DIR/logs/$ref_stash" ||
                clear_stash || die "Cannot initialize stash"
 
+       # Make sure the reflog for stash is kept.
+       : >>"$GIT_DIR/logs/$ref_stash"
+
        # state of the base commit
        if b_commit=$(git rev-parse --verify HEAD)
        then
@@ -125,19 +128,24 @@ apply_stash () {
        c_tree=$(git write-tree) ||
                die 'Cannot apply a stash in the middle of a merge'
 
+       # stash records the work tree, and is a merge between the
+       # base commit (first parent) and the index tree (second parent).
        s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@") &&
        w_tree=$(git rev-parse --verify "$s:") &&
-       b_tree=$(git rev-parse --verify "$s^:") ||
+       b_tree=$(git rev-parse --verify "$s^1:") &&
+       i_tree=$(git rev-parse --verify "$s^2:") ||
                die "$*: no valid stashed state found"
 
-       test -z "$unstash_index" || {
+       unstashed_index_tree=
+       if test -n "$unstash_index" && test "$b_tree" != "$i_tree"
+       then
                git diff --binary $s^2^..$s^2 | git apply --cached
                test $? -ne 0 &&
                        die 'Conflicts in index. Try without --index.'
                unstashed_index_tree=$(git-write-tree) ||
                        die 'Could not save index tree'
                git reset
-       }
+       fi
 
        eval "
                GITHEAD_$w_tree='Stashed changes' &&
@@ -149,18 +157,25 @@ apply_stash () {
        if git-merge-recursive $b_tree -- $c_tree $w_tree
        then
                # No conflict
-               a="$TMP-added" &&
-               git diff --cached --name-only --diff-filter=A $c_tree >"$a" &&
-               git read-tree --reset $c_tree &&
-               git update-index --add --stdin <"$a" ||
-                       die "Cannot unstage modified files"
-               git-status
-               rm -f "$a"
-               test -z "$unstash_index" || git read-tree $unstashed_index_tree
+               if test -n "$unstashed_index_tree"
+               then
+                       git read-tree "$unstashed_index_tree"
+               else
+                       a="$TMP-added" &&
+                       git diff --cached --name-only --diff-filter=A $c_tree >"$a" &&
+                       git read-tree --reset $c_tree &&
+                       git update-index --add --stdin <"$a" ||
+                               die "Cannot unstage modified files"
+                       rm -f "$a"
+               fi
+               git status || :
        else
                # Merge conflict; keep the exit status from merge-recursive
                status=$?
-               test -z "$unstash_index" || echo 'Index was not unstashed.' >&2
+               if test -n "$unstash_index"
+               then
+                       echo >&2 'Index was not unstashed.'
+               fi
                exit $status
        fi
 }